// -*- C++ -*-
// $Id$

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v2.2a_p14
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/

// TAO_IDL - Generated from
// be/be_codegen.cpp:461

#ifndef _TAO_IDL_MONITORS_LGZPBP_H_
#define _TAO_IDL_MONITORS_LGZPBP_H_

#include /**/ "ace/pre.h"

#include "monitorC.h"
#include "dds/DdsDcpsInfrastructureS.h"
#include "dds/DdsDcpsGuidS.h"
#include "tao/ULongSeqS.h"
#include "tao/PortableServer/Basic_SArguments.h"
#include "tao/PortableServer/Special_Basic_SArguments.h"
#include "tao/PortableServer/Fixed_Size_SArgument_T.h"
#include "tao/PortableServer/Var_Size_SArgument_T.h"
#include "tao/PortableServer/Object_SArg_Traits.h"
#include "tao/PortableServer/UB_String_SArguments.h"
#include "tao/PortableServer/get_arg.h"
#include "tao/Special_Basic_Arguments.h"
#include "tao/UB_String_Arguments.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include "tao/PortableServer/PortableServer.h"
#include "tao/PortableServer/Servant_Base.h"

OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_arg_traits.cpp:68


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


// Arg traits specializations.
namespace TAO
{

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::Statistics>
    : public
        Fixed_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::Statistics,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::ValueEnumType>
    : public
        Basic_SArg_Traits_T<
            ::OpenDDS::DCPS::ValueEnumType,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:1058

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::ValueUnion>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::ValueUnion,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::NameValuePair>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::NameValuePair,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::NVPSeq>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::NVPSeq,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::ServiceParticipantReport>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::ServiceParticipantReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DomainParticipantReport>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DomainParticipantReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::TopicReport>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::TopicReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::PublisherReport>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::PublisherReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::SubscriberReport>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::SubscriberReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DataWriterAssociation>
    : public
        Fixed_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DataWriterAssociation,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DWAssociations>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DWAssociations,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DataWriterReport>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DataWriterReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DataWriterAssociationPeriodic>
    : public
        Fixed_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DataWriterAssociationPeriodic,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DWAssociationsPeriodic>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DWAssociationsPeriodic,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DataWriterPeriodicReport>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DataWriterPeriodicReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DataReaderAssociation>
    : public
        Fixed_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DataReaderAssociation,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DRAssociations>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DRAssociations,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DataReaderReport>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DataReaderReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DataReaderAssociationPeriodic>
    : public
        Fixed_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DataReaderAssociationPeriodic,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:685

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DRAssociationsPeriodic>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DRAssociationsPeriodic,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::DataReaderPeriodicReport>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::DataReaderPeriodicReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::TransportReport>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::TransportReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::ReportType>
    : public
        Basic_SArg_Traits_T<
            ::OpenDDS::DCPS::ReportType,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:1058

  template<>
  class SArg_Traits< ::OpenDDS::DCPS::GenericReport>
    : public
        Var_Size_SArg_Traits_T<
            ::OpenDDS::DCPS::GenericReport,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:147

#if !defined (_OPENDDS_DCPS_PROCESSMONITOR__SARG_TRAITS_)
#define _OPENDDS_DCPS_PROCESSMONITOR__SARG_TRAITS_

  template<>
  class  SArg_Traits< ::OpenDDS::DCPS::ProcessMonitor>
    : public
        Object_SArg_Traits_T<
            ::OpenDDS::DCPS::ProcessMonitor_ptr,
            ::OpenDDS::DCPS::ProcessMonitor_var,
            ::OpenDDS::DCPS::ProcessMonitor_out,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

#endif /* end #if !defined */
}

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_module/module_sh.cpp:38

namespace POA_OpenDDS
{
  

  // TAO_IDL - Generated from
  // be/be_visitor_module/module_sh.cpp:38

  namespace DCPS
  {
    

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_sh.cpp:76

    class ProcessMonitor;
    typedef ProcessMonitor *ProcessMonitor_ptr;

    class OpenDDS_monitor_Export ProcessMonitor
      : public virtual PortableServer::ServantBase
    {
    protected:
      ProcessMonitor (void);
    
    public:
      /// Useful for template programming.
      typedef ::OpenDDS::DCPS::ProcessMonitor _stub_type;
      typedef ::OpenDDS::DCPS::ProcessMonitor_ptr _stub_ptr_type;
      typedef ::OpenDDS::DCPS::ProcessMonitor_var _stub_var_type;

      ProcessMonitor (const ProcessMonitor& rhs);
      virtual ~ProcessMonitor (void);

      virtual ::CORBA::Boolean _is_a (const char* logical_type_id);

      virtual void _dispatch (
          TAO_ServerRequest & req,
          TAO::Portable_Server::Servant_Upcall *servant_upcall);
      
      ::OpenDDS::DCPS::ProcessMonitor *_this (void);
      
      virtual const char* _interface_repository_id (void) const;

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::OpenDDS::DCPS::GenericReport * retrieve_report (
        const char * name) = 0;

      static void retrieve_report_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void enable_report_collection (
        void) = 0;

      static void enable_report_collection_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void disable_report_collection (
        void) = 0;

      static void disable_report_collection_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void enable_report_publishing (
        void) = 0;

      static void enable_report_publishing_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void diable_report_publishing (
        void) = 0;

      static void diable_report_publishing_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual void set_publishing_period (
        const ::DDS::Duration_t & period) = 0;

      static void set_publishing_period_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);

      // TAO_IDL - Generated from
      // be/be_visitor_operation/operation_sh.cpp:39

      virtual ::DDS::Duration_t get_publishing_period (
        void) = 0;

      static void get_publishing_period_skel (
          TAO_ServerRequest &server_request,
          TAO::Portable_Server::Servant_Upcall *servant_upcall,
          TAO_ServantBase *servant);
    };
  
  // TAO_IDL - Generated from
  // be/be_visitor_module/module_sh.cpp:69

  } // module OpenDDS::DCPS

// TAO_IDL - Generated from
// be/be_visitor_module/module_sh.cpp:69

} // module OpenDDS

OPENDDS_END_VERSIONED_NAMESPACE_DECL



#include /**/ "ace/post.h"

#endif /* ifndef */

